/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *  MA 02110-1301, USA.
 *
 *  Copyright © 2006 Pierre Habouzit
 */

#ifndef MUTT_LIB_LIB_LIB_LIB_H
#define MUTT_LIB_LIB_LIB_LIB_H

#if HAVE_CONFIG_H
# include "../config.h"
#endif

#ifndef __GNUC__
#  define __attribute__(a)
#endif

/* very common and usual headers we just want to have available {{{ */

#include <assert.h>
#include <ctype.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <limits.h>
#include <regex.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <wchar.h>
#include <wctype.h>

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

#if HAVE_STDINT_H
# include <stdint.h>
#elif HAVE_INTTYPES_H
# include <inttypes.h>
#endif

#ifdef HAVE_SYS_TIME_H
# include <sys/time.h>
#endif

#ifdef HAVE_LOCALE_H
#include <locale.h>
#endif

#ifndef _POSIX_PATH_MAX
#include <posix1_lim.h>
#endif

/* }}} */
/* useful and common macros {{{ */

#ifdef _
#  undef _
#endif

#ifdef ENABLE_NLS
#  include <libintl.h>
#define _(a)       (gettext(a))
#  ifdef gettext_noop
#    define N_(a)  gettext_noop(a)
#  else
#    define N_(a)  (a)
#  endif
#else
#  define _(a)     (a)
#  define N_(a)    (a)
#endif

#define TRUE 1
#define FALSE 0

#undef MAX
#undef MIN
#define MAX(a,b) ((a) < (b) ? (b) : (a))
#define MIN(a,b) ((a) < (b) ? (a) : (b))

/* }}} */

#include "mem.h"
#include "str.h"

#include "array.h"
#include "buffer.h"
#include "date.h"
#include "file.h"
#include "hash.h"
#include "list.h"
#include "mapping.h"
#include "rx.h"
#include "url.h"

#endif
